//*****************************************************************************
//* Enkder interfsz modul.                                                  *
//* Rendszerarchitektrk labor, 2. EDK-s mrs.                              *
//*****************************************************************************
module user_logic(
   //A PLB IPIF interfsz portjai.
   Bus2IP_Clk,                     //rajel.
   Bus2IP_Reset,                   //Reset jel.
   Bus2IP_Data,                    //rsi adatbusz (IPIF -> IP).
   Bus2IP_BE,                      //Bjt engedlyez jelek.
   Bus2IP_RdCE,                    //Regiszter olvass engedlyez jelek.
   Bus2IP_WrCE,                    //Regiszter rs engedlyez jelek.
   IP2Bus_Data,                    //Olvassi adatbusz (IP -> IPIF).
   IP2Bus_RdAck,                   //Regiszter olvass nyugtz jel.
   IP2Bus_WrAck,                   //Regiszter rs nyugtz jel.
   IP2Bus_Error,                   //Hibajelzs az IPIF fel.
   
   //Az enkder interfsz portjai.
   encoder_a,                      //Az enkder A jele.
   encoder_b,                      //Az enkder B jele.
   irq                             //Megszaktskr kimenet.
);

//*****************************************************************************
//* A PLB IPIF interfsz paramterei (EZEKET NE MDOSTSA!).                  *
//*****************************************************************************
parameter C_SLV_DWIDTH = 32;
parameter C_NUM_REG    = 2;


//*****************************************************************************
//* A PLB IPIF interfsz portjainak definilsa (EZEKET NE MDOSTSA!).       *
//*****************************************************************************
input  wire                        Bus2IP_Clk;
input  wire                        Bus2IP_Reset;
input  wire [0 : C_SLV_DWIDTH-1]   Bus2IP_Data;
input  wire [0 : C_SLV_DWIDTH/8-1] Bus2IP_BE;
input  wire [0 : C_NUM_REG-1]      Bus2IP_RdCE;
input  wire [0 : C_NUM_REG-1]      Bus2IP_WrCE;
output reg  [0 : C_SLV_DWIDTH-1]   IP2Bus_Data;
output wire                        IP2Bus_RdAck;
output wire                        IP2Bus_WrAck;
output wire                        IP2Bus_Error;


//*****************************************************************************
//* Az enkder interfsz portjainak definilsa (EZEKET NE MDOSTSA!).       *
//*****************************************************************************
input  wire                        encoder_a;
input  wire                        encoder_b;
output wire                        irq;


//*****************************************************************************
//* Az rsi adatbusz bitjeinek megfordtsa.                                 *
//* A tovbbiakban a Bus2IP_Data jel helyett hasznlja a wr_data jelet.       *
//*****************************************************************************
reg     [C_SLV_DWIDTH-1:0] wr_data;
integer                    i;

always @(*)
   for (i = 0; i < C_SLV_DWIDTH; i = i + 1)
      wr_data[i] <= Bus2IP_Data[C_SLV_DWIDTH-i-1];
      

//*****************************************************************************
//* A nyugtz- s hibajelek meghajtsa.                                      *
//*****************************************************************************
assign IP2Bus_WrAck =
assign IP2Bus_RdAck =
assign IP2Bus_Error =


//*****************************************************************************
//* Az enkder jeleinek mintavtelezse 1 kHz-el s az esemnyek dekdolsa.  *
//*****************************************************************************


//*****************************************************************************
//* Vezrl/sttusz regiszter (BZIS+0x00).                                   *
//* A megszaktskr jel ellltsa.                                        *
//*****************************************************************************


//*****************************************************************************
//* Szmll (BZIS+0x04).                                                    *
//*****************************************************************************


//*****************************************************************************
//* Az olvassi adatbusz meghajtsa.                                          *
//*****************************************************************************


endmodule
